Attribute VB_Name = "ModParticle"
Private Type Explosion  'Creates the Explosion Type
    Xpos As Double      'X Position of the Particle
    YPos As Double      'Y Position of the Particle
    XVelo As Double     'X Velocity of the Particle
    YVelo As Double     'Y Velocity of the Particle
    Colour As Double    'Colour of the particle
End Type

Private Type Clean      'Creates the Cleaning Type
    Xpos As Double      'X Position of the Particle
    YPos As Double      'Y Position of the Particle
    Colour As Double    'Current Colour of the Particle
End Type

Dim Wind                            'Vlaue of Wind
Dim Gravity                         'Value of Gravity
Dim CleanUp(1 To 255000) As Clean   'Creates the CleanUp Array
Dim Bang(1 To 1000) As Explosion    'Creates the Bang Array
Dim MaxCleanUp As Double                    'Size of CleanUp
Dim FinishedRendering As Boolean    'Check if Finished Rendering Particle
Dim StillRendering As Boolean       'Check if Still Rendering Particle
Dim FinishedCleaning As Boolean     'Check if Finished Cleaning Particle
Dim StillCleaning As Boolean        'Check if Still Cleaning Particle

Sub DoParticles(X, Y, HowBig, MultiPlier)   'Starting SubRoutine
    Randomize   'Randomize the Values

    Gravity = Rnd * 0.25
    
    MaxCleanUp = 0  'Set the Size of CleanUp to 0
    For SetParticle = 1 To HowBig   'Loop to Set Particle Values
        Bang(SetParticle).Xpos = X  'Set the X Position
        Bang(SetParticle).YPos = Y  'Set the Y Position
        Bang(SetParticle).Colour = 200  'Set the Colour of the Explosion
        Bang(SetParticle).XVelo = Rnd * (2 * MultiPlier) - MultiPlier   'Sets the X Velocity of the Particle
        Bang(SetParticle).YVelo = Rnd * (2 * MultiPlier) - MultiPlier   'Sets the Y Velocity of the Particle
    Next
    Call RenderParticles(HowBig)    'Call the Rendering Sub Routine
End Sub

Sub RenderParticles(HowBig) 'Renders the Particles
    FinishedRendering = False   'Has not Finished Rendering the Particles
    While FinishedRendering = False 'Loop until Finished Rendering is True
        DoEvents    'Let Windows Carry on, stops Program Freezing
        StillRendering = False  'Not Rendering
        For DoRendering = 1 To HowBig   'Loops to Render Particles
            If Bang(DoRendering).Colour > 0 Then    'Only Render if Particle still has Life
                MaxCleanUp = MaxCleanUp + 1 'Adds to CleanUp
                CleanUp(MaxCleanUp).Xpos = Bang(DoRendering).Xpos   'Sets CleanUps X Position
                CleanUp(MaxCleanUp).YPos = Bang(DoRendering).YPos   'Sets CleanUps Y Position
                CleanUp(MaxCleanUp).Colour = Bang(DoRendering).Colour   'Sets CleanUps Colour
                Bang(DoRendering).Xpos = Bang(DoRendering).Xpos + Bang(DoRendering).XVelo   'Adds to X Position the X Velocity
                Bang(DoRendering).YPos = Bang(DoRendering).YPos + Bang(DoRendering).YVelo   'Adds to Y Position the Y Velocity
                FrmParticle.ForeColor = RGB(0, Bang(DoRendering).Colour, 0)
                FrmParticle.Line (Bang(DoRendering).Xpos, Bang(DoRendering).YPos)-(Bang(DoRendering).Xpos + 10, Bang(DoRendering).YPos + 10)
                Bang(DoRendering).YVelo = Bang(DoRendering).YVelo + Gravity
                Bang(DoRendering).XVelo = Bang(DoRendering).XVelo - Wind
                Bang(DoRendering).Colour = Bang(DoRendering).Colour - 1
                StillRendering = True
            End If
        Next
        If StillRendering = False Then
            FinishedRendering = True
        End If
    Wend
    Call CleanParticles
End Sub

Sub CleanParticles()

    FinishedCleaning = False
    
    While FinishedCleaning = False
        DoEvents
        StillCleaning = False
        For DoCleaning = 1 To MaxCleanUp
            If CleanUp(DoCleaning).Colour > 0 Then
                CleanUp(DoCleaning).Colour = CleanUp(DoCleaning).Colour - (MaxCleanUp / 2550)
                If CleanUp(DoCleaning).Colour < 0 Then
                    CleanUp(DoCleaning).Colour = 0
                End If
                FrmParticle.ForeColor = RGB(0, CleanUp(DoCleaning).Colour, 0)
                FrmParticle.Line (CleanUp(DoCleaning).Xpos, CleanUp(DoCleaning).YPos)-(CleanUp(DoCleaning).Xpos + 10, CleanUp(DoCleaning).YPos + 10)
                StillCleaning = True
            End If
        Next
        If StillCleaning = False Then
            FinishedCleaning = True
        End If
    Wend
End Sub
